<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\training;


use app\common\model\training\TrainingBlockConfig;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * TrainingBlockConfig逻辑
 * Class TrainingBlockConfigLogic
 * @package app\adminapi\logic
 */
class TrainingBlockConfigLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/06 18:08
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            TrainingBlockConfig::create([
                'identity_source' => $params['identity_source'],
                'block_setting' => self::configureReservedField($params['block_setting']??[]),
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/06 18:08
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            TrainingBlockConfig::where('id', $params['id'])->update([
                'identity_source' => $params['identity_source'],
                'block_setting' => json_encode(self::configureReservedField($params['block_setting']??[])),
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/06 18:08
     */
    public static function delete(array $params): bool
    {
        return TrainingBlockConfig::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/03/06 18:08
     */
    public static function detail($params): array
    {
        return TrainingBlockConfig::findOrEmpty($params['id'])->toArray();
    }


    public static function configureReservedField($data): array
    {
        foreach ($data as $key => &$item) {
            $data[$key]['block_key'] = $key+1;
            if($item['is_must']){
                $item['is_must'] = \true;
            }else{
                $item['is_must'] = \false;
            }
        }
        return $data??[];
    }


    public static function getBlockConfig($identity_source,$type = 'all')
    {
        $block_setting = TrainingBlockConfig::where('identity_source',$identity_source)->value('block_setting');
        $settings = [];
        if($block_setting){
            $block_setting = json_decode($block_setting,true);
            $settings = array_column($block_setting,'type_value','type');
        }
        return ($type==='all')?$settings:($settings[$type]??[]);
    }

    public static function getRequiredConfig($identity_source)
    {
        $block_setting = TrainingBlockConfig::where('identity_source',$identity_source)->value('block_setting');
        $settings = [];
        if($block_setting){
            $settings = json_decode($block_setting,true);
        }
        return $settings??[];
    }


}